<?php
defined( 'ABSPATH' ) or die;

function d3gb_get_sequence($gbID){

  $r = sanitize_text_field($_GET['r']);
  $r = d3gb_location_decode($r);
  $chr = $r['chr'];
  $start = $r['start'];
  $end = $r['end'];
  $r = "$chr:$start-$end";

  $name = isset($_GET['n'])?str_replace('\\','',sanitize_text_field($_GET['n'])):0;
  $score = isset($_GET["score"])?sanitize_text_field($_GET['score']):0;
  $reverse_strand = isset($_GET["strand"]) && $_GET["strand"]=="reverse";

  $Fa = D3GB_DATA_DIR.'/'.$gbID."/sequences/$chr.fa";
  $handle = fopen($Fa,"r");
  if($handle){
    fgets($handle);
    fseek($handle,$start,SEEK_CUR);
    $dna = fread($handle,($end-$start));
    fclose($handle);
    $dna = strtolower($dna);

    $thickStart = isset($_GET["thickStart"])?intval($_GET["thickStart"]):$start;
    $thickEnd = isset($_GET["thickEnd"])?intval($_GET["thickEnd"]):$end;
    $thickSize = $thickEnd-$thickStart;

    if(isset($_GET["blockCount"])){
      $count = intval($_GET["blockCount"]);
      $sizes = sanitize_text_field($_GET["blockSizes"]);
      $sizes = preg_replace("/[^0-9,]/","",$sizes);
      $sizes = explode(',',$sizes);
      $starts = sanitize_text_field($_GET["blockStarts"]);
      $starts = preg_replace("/[^0-9,]/","",$starts);
      $starts = explode(',',$starts);
      $clean = "N";
      $clean = str_pad($clean, strlen($dna),"N");
      for($i = 0; $i < $count; ++$i) {
        $clean = substr_replace($clean,substr($dna,$starts[$i],$sizes[$i]),$starts[$i],$sizes[$i]);
      }
      $dna = $clean;
    }

    if($reverse_strand){
      $reverse = "";
      for($i = strlen($dna)-1; $i >= 0; --$i) {
        switch ($dna[$i]) {
          case 'a':
            $reverse = $reverse.'t';
            break;
          case 't':
            $reverse = $reverse.'a';
            break;
          case 'g':
            $reverse = $reverse.'c';
            break;
          case 'c':
            $reverse = $reverse.'g';
            break;
          case 'N':
            $reverse = $reverse.'N';
            break;
        }
      }
      $dna = $reverse;
      $thickStart = $end-$thickEnd;
    }else{
      $thickStart = $thickStart-$start;
    }

    if($name){
      if(isset($_GET["thickStart"])&&isset($_GET["thickEnd"])){
        $dnaProt = substr($dna,$thickStart,$thickSize);
      }else{
        $dnaProt = $dna;
      }
      if(isset($_GET["blockCount"])){
        $dnaProt = str_replace("N","",$dnaProt);
        $dna = str_replace("N","",$dna);
      }
      $prot = "";
      for($i = 0; $i < strlen($dnaProt); $i = $i+3){
        $cod = substr($dnaProt, $i, 3);
        switch ($cod){
              case 'gct':
              case 'gcc':
              case 'gca':
              case 'gcg':
                $cod = 'A';
                break;
              case 'cgt':
              case 'cgc':
              case 'cga':
              case 'cgg':
              case 'aga':
              case 'agg':
                $cod = 'R';
                break;
              case 'aat':
              case 'aac':
                $cod = 'N';
                break;
              case 'gat':
              case 'gac':
                $cod = 'D';
                break;
              case 'tgt':
              case 'tgc':
                $cod = 'C';
                break;
              case 'gaa':
              case 'gag':
                $cod = 'E';
                break;
              case 'caa':
              case 'cag':
                $cod = 'Q';
                break;
              case 'ggt':
              case 'ggc':
              case 'gga':
              case 'ggg':
                $cod = 'G';
                break;
              case 'cat':
              case 'cac':
                $cod = 'H';
                break;
              case 'att':
              case 'atc':
              case 'ata':
                $cod = 'I';
                break;
              case 'tta':
              case 'ttg':
              case 'ctt':
              case 'ctc':
              case 'cta':
              case 'ctg':
                $cod = 'L';
                break;
              case 'aaa':
              case 'aag':
                $cod = 'K';
                break;
              case 'atg':
                $cod = 'M';
                break;
              case 'ttt':
              case 'ttc':
                $cod = 'F';
                break;
              case 'cct':
              case 'ccc':
              case 'cca':
              case 'ccg':
                $cod = 'P';
                break;
              case 'tct':
              case 'tcc':
              case 'tca':
              case 'tcg':
              case 'agt':
              case 'agc':
                $cod = 'S';
                break;
              case 'act':
              case 'acc':
              case 'aca':
              case 'acg':
                $cod = 'T';
                break;
              case 'tgg':
                $cod = 'W';
                break;
              case 'tat':
              case 'tac':
                $cod = 'Y';
                break;
              case 'gtt':
              case 'gtc':
              case 'gta':
              case 'gtg':
                $cod = 'V';
                break;
              case 'taa':
              case 'tag':
              case 'tga':
                $cod = '*';
                break;
              default:
                $cod = 'X';
        }
        $prot = $prot.$cod;
      }
      for($i = 50; $i < strlen($prot); $i = $i+51)
        $prot = substr_replace($prot,"\n",$i,0);
      echo "<h3>$name</h3>
          <p>$r</p>";
      if($score)
        echo "<ul><li>".str_replace("|","</li><li>",$score)."</li></ul>";
?>
<button onclick='download();'>download</button>
<button onclick='change();'>dna/protein</button>
<pre style='display:none'><?php echo ">$name\n$prot"; ?></pre>
<script>
  function change(){
    var pre = document.querySelectorAll('pre'),
        but = document.querySelectorAll('button');
    if(pre[0].style.display == 'none'){
      pre[0].style.display = 'block';
      pre[1].style.display = 'none';
    }else{
      pre[1].style.display = 'block';
      pre[0].style.display = 'none';
    }
  }
</script>
<?php
    }else
      $name = $r;

    for($i = 50; $i < strlen($dna); $i = $i+51)
      $dna = substr_replace($dna,"\n",$i,0);
?>
<pre><?php echo ">$name\n$dna"; ?></pre>
<script>
  function download(){ 
    var reader = new FileReader();
    reader.onload = function (event) {
	    var save = document.createElement('a');
	    save.href = event.target.result;
	    save.target = '_blank';
	    save.download = '<?php echo $name; ?>.fa';
	    var clicEvent = new MouseEvent('click', {
	      'view': window,
	      'bubbles': true,
	      'cancelable': true
	    });
	    save.dispatchEvent(clicEvent);
	    (window.URL || window.webkitURL).revokeObjectURL(save.href);
    };
    var texto = [];
    texto.push(document.querySelector('pre').textContent);
    var blob = new Blob(texto, {type: 'text/plain'});
    reader.readAsDataURL(blob);
  }
</script>
<?php
  } else {
    echo "Sequence not found!";
  }
}
