<?php
defined( 'ABSPATH' ) or die;

function d3gb_query_callback() {

  global $wpdb;
  $res = NULL;

if(isset($_POST['gb'])) {
  $gb = intval($_POST['gb']);

  $tracks = $wpdb->prefix."d3gb_".$gb."_tracks";
  $segments = $wpdb->prefix."d3gb_".$gb."_segments";
  $tbl_genes = $wpdb->prefix."d3gb_".$gb."_genes";

  if(isset($_POST['chromosome'])) {
    $chromosome = sanitize_text_field($_POST['chromosome']);
    $sql = $wpdb->prepare("SELECT start,end,name,score FROM $segments INNER JOIN $tracks ON $segments.trackid=$tracks.trackid WHERE chr=%s AND type=%s;",$chromosome,"chromosomes");
    $res = $wpdb->get_results($sql, ARRAY_N);
  }

  if(isset($_POST['genes'])) {
    $genes = sanitize_text_field($_POST['genes']);
    $sql = $wpdb->prepare("SELECT chr, start, end, name, score FROM $tbl_genes WHERE name LIKE %s LIMIT 100;",$genes."%");
    $res = $wpdb->get_results($sql, ARRAY_N);
  }

  if(isset($_POST['random'])) {
    $sql = "SELECT max(n) FROM $tbl_genes";
    $n = $wpdb->get_var($sql);
    $n = rand(1,$n);
    $sql = $wpdb->prepare("SELECT chr, start, end, name FROM $tbl_genes WHERE n=%d LIMIT 1;",$n);
    $res = $wpdb->get_results($sql, ARRAY_N);
  }

  if(isset($_POST['scores'])) {
    $scores = sanitize_text_field($_POST['scores']);
    $term = "%".$scores."%";
    $sql = $wpdb->prepare("SELECT chr, start, end, name, score FROM $tbl_genes WHERE name LIKE %s OR score LIKE %s LIMIT 100;",$term,$term);
    $res = $wpdb->get_results($sql, ARRAY_N);
  }

  if(isset($_POST['r'])) {
    $r = sanitize_text_field($_POST['r']);
    $r = d3gb_location_decode($r);
    $chr = $r['chr'];
    $start = $r['start'];
    $end = $r['end'];

    $current_region = $wpdb->prefix . uniqid("d3gb_");

    $from_region = $wpdb->prepare("FROM $segments WHERE chr=%s AND (start BETWEEN %d AND %d OR end BETWEEN %s AND %s OR %s BETWEEN start AND end OR %d BETWEEN start AND end)",$chr,$start,$end,$start,$end,$start,$end);
    $sql = $wpdb->prepare("CREATE TEMPORARY TABLE $current_region AS SELECT * $from_region LIMIT %d",6000);
    $wpdb->query($sql);

    $sql = "SELECT count(*) from $current_region";
    $count = $wpdb->get_var($sql);
    if($count<6000){
      $from_region = $wpdb->prepare("FROM $current_region WHERE %d",1);
    }

    $res = array();
    $sql = "SELECT trackid,count(trackid) $from_region GROUP BY trackid";
    $tracks = $wpdb->get_results($sql, ARRAY_N);
    foreach ($tracks as $track){
      if($track[1]!=0){
        if($track[1]>1000){
          $res['track'.$track[0]] = [[0,intval($track[0]),FALSE]];
        }else{
          $sql = $wpdb->prepare("SELECT * $from_region AND trackid=%d ORDER BY start",$track[0]);
          $result = $wpdb->get_results($sql, ARRAY_N);
          $res['track'.$track[0]] = [];
          foreach ($result as $row){
            foreach([0,1,3,4,8,9,11] as $i)
              $row[$i] = intval($row[$i]);
            $res['track'.$track[0]][] = $row;
          }
        }
      }
    }
  }
}

  echo json_encode($res);
  wp_die();
}
