<?php
defined( 'ABSPATH' ) or die;

function d3gb_render_gb($gbID){
  global $wpdb;
  $tbl_d3gb = $wpdb->prefix."d3gb";
  $tbl_tracks = $wpdb->prefix."d3gb_".$gbID."_tracks";
  $tbl_segments = $wpdb->prefix."d3gb_".$gbID."_segments";

  $sql = $wpdb->prepare("SELECT ID FROM $tbl_d3gb WHERE ID=%d",$gbID);
  if($gbID != $wpdb->get_var($sql)){
    echo "Genome browser not found!";
    return;
  }

  $sql = $wpdb->prepare("SELECT max(end) FROM $tbl_segments INNER JOIN $tbl_tracks ON $tbl_segments.trackid=$tbl_tracks.trackid WHERE type=%s;","chromosomes");
  $max_length = $wpdb->get_var($sql);

  $sql = $wpdb->prepare("SELECT DISTINCT chr FROM $tbl_segments INNER JOIN $tbl_tracks ON $tbl_segments.trackid=$tbl_tracks.trackid WHERE type=%s;","chromosomes");
  $chromosomes = $wpdb->get_col($sql);
  $data_chr = array();
  foreach($chromosomes as $chr) {
    $sql = $wpdb->prepare("SELECT start,end,score FROM $tbl_segments INNER JOIN $tbl_tracks ON $tbl_segments.trackid=$tbl_tracks.trackid WHERE type=%s AND chr=%s;","maptrack",$chr);
    $data = $wpdb->get_results($sql,ARRAY_N);
    for($i=0;$i<count($data);$i++){
      $data[$i][0] = intval($data[$i][0]);
      $data[$i][1] = intval($data[$i][1]);
      $data[$i][2] = floatval($data[$i][2]);
    }
    $data_chr[$chr] = $data;
  }
  $sql = $wpdb->prepare("SELECT scale FROM $tbl_tracks WHERE type=%s;","maptrack");
  $data_scale = json_decode($wpdb->get_var($sql));
  $sql = $wpdb->prepare("SELECT color FROM $tbl_tracks WHERE type=%s;","maptrack");
  $data_color = $wpdb->get_var($sql);
  $data = array("data"=>$data_chr,"max"=>intval($max_length),"count"=>count($data_chr),"scale"=>$data_scale,"color"=>$data_color);
  $scripts_url = plugins_url("/js/",plugin_dir_path(__FILE__));
  $query_url = admin_url( 'admin-ajax.php' );

?>
<style>
div.plot * { font-family: sans-serif !important; }
div.plot button, div.plot input[type=button], div.plot button:hover { all:initial; cursor: pointer; border: solid 1px #a0a0a0; background-color: #eeeeee; padding: 4px 6px; margin: 2px; color: #303030; }
div.plot button:disabled { color:#a0a0a0; }
div.plot input { all:initial; border: solid 1px #a0a0a0; background-color:#ffffff; padding: 4px; margin-right: 4px; }
div.plot a, div.plot a:hover, div.plot a:visited, div.plot a:link, div.plot a:active { all: initial; }
div.plot div.tooltip { background-color: #fff; padding: 8px 14px; border-radius: 6px; border: 2px solid #ddd;}
div.plot div.tooltip * { font-size: 12px !important; }
div.plot div.tooltip p { all: initial; display: block; padding: 2px 4px; }
span.highlight { background-color: #ffffaa; }
div.bioinfo { float:right; padding-right:50px; }
div.bioinfo::after { content: ''; display: block; clear: both; }
</style>
<div class="plot"></div>
<div class="bioinfo"></div>
<?php
  echo "<script type=\"text/javascript\" src=\"".$scripts_url."d3.min.js\"></script>\n";
  echo "<script type=\"text/javascript\">\nvar gbID = ".$gbID.",\n queryUrl = '$query_url',\n  data = ".json_encode($data).";\n</script>\n";
  echo "<script type=\"text/javascript\" src=\"".$scripts_url."genomemap.js\"></script>\n";

  $sql = $wpdb->prepare("SELECT trackid FROM $tbl_tracks WHERE type != %s AND type != %s","chromosomes","maptrack");
  $tracks = $wpdb->get_results($sql);
  if(count($tracks)>0){
    $sql = $wpdb->prepare("SELECT trackid, trackname, type, color, scale FROM $tbl_tracks WHERE type != %s AND type != %s;","chromosomes","maptrack");
    $data_tracks = $wpdb->get_results($sql,ARRAY_N);
    echo "<script type=\"text/javascript\">\nbioinfoLogo();\nvar dataTracks = ".json_encode($data_tracks).";\n</script>\n";
    echo "<script type=\"text/javascript\" src=\"".$scripts_url."genomebrowser.js\"></script>\n";
  }else{
    echo "<script type=\"text/javascript\">genomemap();</script>\n";
  }
}
